/**
 * client.js
 */

const debug     = require('debug')('light:client');
const developer = require('./lib/developer');
const setting   = require('./lib/setting');
const log       = require('./lib/log');
const rider     = require('./lib/model/datarider');
const pool      = require('./lib/db/mongo/pool');

class Client {

  /**
   * 初始化运行环境
   */
  static async init() {

    debug('init client app');
    developer.loadConfig();

    try {
      await setting.init();
      rider.init();
    } catch (err) {
      log.error(err);
      process.exit(-1);
    }

  }

  static async destory() {
    await pool.destroy();
  }

}

if (!module.parent) Client.init();
module.exports = Client;
