/**
 * @file 对外接口定义
 * @author r2space@gmail.com
 */

'use strict';

module.exports = {
  developer : require('./lib/developer'),
  config    : require('./lib/configuration'),
  Context   : require('./lib/context'),
  CONST     : require('./lib/constant'),
  error     : require('./lib/error'),
  excel     : require('./lib/model/datamigrate/excel'),
  helper    : require('./lib/helper'),
  job       : require('./lib/job'),
  light     : require('./lib/model/light'),
  log       : require('./lib/log'),
  logger    : require('debug'),
  migrate   : require('./lib/model/datamigrate'),
  middleware: require('./lib/middleware'),
  mq        : require('./lib/mq'),
  mysql     : {
    controller: require('./lib/db/mysql/controller'),
    model     : require('./lib/db/mysql/model')
  },
  mongodb: {
    controller: require('./lib/db/mongo/controller'),
    connection: require('./lib/db/mongo/connection'),
    model     : require('./lib/db/mongo/model')
  },
  notice    : require('./lib/notice'),
  permission: require('./lib/permission'),
  process   : require('./lib/model/process'),
  response  : require('./lib/response'),
  rider     : require('./lib/model/datarider'),
  socket    : require('./lib/socket'),
  security  : require('./lib/security'),
  setting   : require('./lib/setting'),
  udp       : require('./lib/udp')
};
