/**
 * jest.config.js
 */

'use strict';

require('dotenv').config();

module.exports = {

  // 只对js文件进行测试
  moduleFileExtensions: ['js'],

  testEnvironment: 'node',

  testMatch: [

    // 基础功能测试
    // '**/test/lib/configuration.test.js',
    // '**/test/lib/log.test.js',
    // '**/test/lib/i18n.test.js',
    // '**/test/lib/setting.test.js',
    // '**/test/lib/socket.test.js',
    // '**/test/lib/validator.test.js',
    // '**/test/lib/security.test.js',
    // '**/test/bin/pull.test.js'
    // '**/test/bin/push.test.js'
    // '**/test/lib/job.test.js'
    // '**/test/lib/helper.test.js',
    // '**/test/lib/helper/aksk.test.js'
    // '**/test/app.test.js'

    // 数据库操作
    // '**/test/lib/db/mongo/type.test.js'
    // '**/test/lib/db/mongo/connection.test.js',
    // '**/test/lib/db/mongo/pool.test.js'
    // '**/test/lib/db/mongo/operator.test.js'
    // '**/test/lib/db/mongo/mapping.test.js'
    // '**/test/lib/db/mongo/model.test.js',
    // '**/test/lib/db/mongo/controller.test.js',

    // 中间件测试
    // '**/test/lib/middleware/index.test.js',
    // '**/test/lib/middleware/access-log.test.js',
    // '**/test/lib/middleware/auth-cookie.test.js',
    // '**/test/lib/middleware/auth-jwt.test.js',
    // '**/test/lib/middleware/body-parse.test.js',
    // '**/test/lib/middleware/csrf-check.test.js',
    // '**/test/lib/middleware/health-check.test.js',
    // '**/test/lib/middleware/helmet.test.js',
    // '**/test/lib/middleware/i18n.test.js',
    // '**/test/lib/middleware/method-override.test.js',
    // '**/test/lib/middleware/query-parse.test.js',
    // '**/test/lib/middleware/router.test.js',
    // '**/test/lib/middleware/session.test.js',
    // '**/test/lib/middleware/timeout.test.js',
    // '**/test/lib/middleware/static.test.js',
    // '**/test/lib/middleware/xml-parse.test.js'

    // Model相关
    // '**/test/lib/model/datarider/index.test.js',
    // '**/test/lib/model/datarider/mongo.test.js',
    // '**/test/lib/model/datamigrate/excel.test.js',
    // '**/test/lib/model/datamigrate/exporter.test.js',
    // '**/test/lib/model/datamigrate/importer.test.js',
    // '**/test/lib/model/datamigrate/common.test.js',
    // '**/test/lib/model/file.test.js'
  ],

  coverageDirectory  : './coverage/jest',
  coverageReporters  : ['html'],
  collectCoverageFrom: [
    'app.js',
    'lib/**/*.js'
  ]
};
