/**
 * 匹配数组中所有元素，与$and操作符检索相同
 *
 * {
 *  field: { $all: [ value1 , value2 ] }
 * }
 */

const debug = require('debug')('light:db:mongo:operator')
  , mapping = require('../mapping')
  , type = require('../type');

exports.parse = function (value, defines, addition, kind = '$all') {
  debug(kind, 'parse', value, defines);

  let define = defines;
  if (defines.contents) {
    define = type.isJson(defines.contents)
      ? defines.contents
      : { type: defines.contents };
  }

  // 值必须是数组
  let result = type.parse(value, { type: 'array' }, addition);
  result = result.map(item => (type.isJson(item)
    ? mapping.parse(item, define, addition)
    : mapping.parseItem(item, define, addition)));

  debug(kind, 'parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $all: value } };
};
