/**
 * 与条件
 *
 * {
 *  $and: [
 *    { $or: [ {a: 1}, {b: 1} ] },
 *    { c: { $ne: 10 } },
 *    { d: 12 }
 *  ]
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , mapping = require('../mapping')
  , type = require('../type');

exports.parse = function (value, define, addition, kind = '$and') {

  debug(kind, 'parse', value, define);

  // 值必须是数组
  let result = type.parse(value, { type: 'array' }, addition);
  result = result.map(item => mapping.parse(item, define));

  debug(kind, 'parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { $and: value };
};
