/**
 * 位运算
 *
 * {
 *  $bit: {
 *    a: { and: 1 },
 *    b: { or: 2 },
 *    c: { xor: 4 },
 *  }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (value, define, addition) {
  debug('$bit parse', value);
  assert(type.isJson(value), 'invalid $bit value');

  Object.keys(value).forEach(key => {

    assert(type.isJson(value[key]), 'invalid $bit operation');
    Object.keys(value[key]).forEach(itemKey => {

      // key 只能是 and or xor
      assert(['and', 'or', 'xor'].includes(itemKey), 'invalid $bit operation key');

      value[key][itemKey] = type.parse(value[key][itemKey], { type: 'number' }, addition);

      // 值必须是数字
      assert(type.isJson(value[key]), 'invalid $bit operation value');
    });

  });

  debug('$bit parsed', value);
  return value;
};
