/**
 * 等于
 *
 * {
 *  a: { $eq: '10' }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , mapping = require('../mapping');

exports.parse = function (value, define, addition, kind = '$eq') {

  debug(kind, 'parse', value, define);

  // 判断define是不是单个元素的定义（单个元素的定义一定包含type）
  const result = define.type
    ? mapping.parseItem(value, define, addition)
    : mapping.parse(value, define, addition);

  debug(kind, 'parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $eq: value } };
};
