/**
 * 确认指定的字段是否存在
 * {
 *  a: { $exists: true }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , mapping = require('../mapping');

exports.parse = function (value, define, addition) {
  debug('$exists parse', value);

  // 值一定是bool型
  const result = mapping.parseItem(value, { type: 'boolean' }, addition);

  debug('$exists parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $exists: value } };
};
