/**
 * 对指定字段进行增量计算，支持子文档
 * 不管定义是什么类型，遇到该操作符时，值一律转换为数字
 *
 * {
 *  $inc: {
 *    quantity: -2,
 *    'metrics.orders': 1
 *  }
 * }
 *
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (object) {

  debug('$inc parse', object);
  assert(type.isJson(object), 'invalid $inc value');

  // 值一律转换为数字
  Object.keys(object).forEach(key => {
    object[key] = type.parse(object[key], { type: 'number' });
  });

  debug('$inc parsed', object);
  return object;
};
