/**
 * 指定的值小于当前值时更新
 *
 * {
 *  $min: {
 *    num: 950,
 *    parent.str: 'a',
 *    date: ISODate('2013-10-01T05:00:00Z'),
 *    array: [1, 2],
 *    json: {a: 1}
 *  }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type')
  , mapping = require('../mapping');

exports.parse = function (value, define, addition, kind = '$min') {
  debug(kind, 'parse', value);
  assert(type.isJson(value), `invalid ${kind} value`);

  const result = mapping.parse(value, define, addition);

  debug(kind, 'parsed', value);
  return result;
};
