/**
 * 对指定字段进行mod运算
 *
 * {
 *  field: { $mod: [ divisor, remainder ] }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (value) {

  debug('$mod parse', value);

  let result = type.parse(value, { type: 'array' });
  assert(result.length === 2, 'invalid $mod value');

  result = result.map(item => type.parse(item, { type: 'number' }));

  debug('$mod parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $mod: value } };
};
