/**
 * 指定的值不在列表中
 *
 * {
 *  a: { $nin: [1] }
 * }
 */

'use strict';

const $in = require('./$in');

exports.parse = function (value, define, addition) {
  return $in.parse(value, define, addition, '$nin');
};

exports.compare = function (field, value) {

  // nin比较，如果传递的是字符串，尝试转换成数组
  if (typeof value === 'string') {
    return { [field]: { $nin: value.split(',').map(item => item.trim()) } };
  }

  return { [field]: { $nin: value } };
};
