/**
 * 删除数组的第一个或最后一个元素
 *
 * {
 *   $pop: {
 *     num: 1
 *   }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (object) {

  debug('$pop parse', object);
  assert(type.isJson(object), 'invalid $pop value');

  Object.keys(object).forEach(key => {

    // 先转为数字
    const num = type.dataParse(object[key], { type: 'number' });

    // 再转为 1 或 -1
    object[key] = num > 0 ? 1 : -1;
  });

  debug('$pop parsed', object);
  return object;
};
