/**
 * 正则匹配，可以使用$options指定参数
 *
 * {
 *  field: {
 *    $regex: /^$/, $options: 'i',
 *    $regex: /^$/i
 *  }
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (value, define, addition) {
  debug('$regex parse', value, 'option', addition);

  const isString = typeof value === 'string' || value instanceof String
    , isRegExp = value instanceof RegExp;

  assert(isString || isRegExp, 'invalid $regex value');

  const result = type.parse(value, { type: 'regex' });

  debug('$regex parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $regex: value } };
};
