/**
 * 重命名字段名
 *
 * {
 *  $rename: {
 *    a: 'b'
 *  }
 * }
 *
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , assert = require('assert').strict
  , type = require('../type');

exports.parse = function (value) {

  debug('$rename parse', value);
  assert(type.isJson(value), 'invalid $rename value');

  Object.keys(value).forEach(key => {
    value[key] = type.parse(value[key], { type: 'string' });
  });

  debug('$rename parsed', value);
  return value;
};
