/**
 * 限制更新后的数组总长度，与$each结合使用
 *
 * {
 *  $push: [
 *    a: {
 *      $each: [1, 2, 3],
 *      $slice: 3
 *    }
 *  ]
 * }
 */

'use strict';

const debug = require('debug')('light:db:mongo:operator')
  , type = require('../type');

exports.parse = function (value, define, addition, kind = '$position') {
  debug(kind, 'parse', value);
  const result = type.parse(value, { type: 'number' });
  debug(kind, 'parsed', result);
  return result;
};

exports.compare = function (field, value) {
  return { [field]: { $slice: value } };
};
