/**
 * 数组类型转换
 */

'use strict';

const debug = require('debug')('light:db:mongo:type');
const type  = require('./index');

exports.parse = function (param, define = {}) {

  // 允许通过define，指定值为空时取值。默认是 []
  let defaults = [];
  if (define.default === 'undefined') {
    defaults = undefined;
  }
  if (define.default === 'null') {
    defaults = null;
  }

  const value = param instanceof String ? param.valueOf() : param;
  if (type.isBlank(value)) {
    debug('is blank');
    return defaults;
  }

  let data = value;
  if (typeof value === 'string') {
    try {
      data = JSON.parse(value);
      debug('json parsed', data);

      if (type.isBlank(data)) {
        debug('is blank');
        return defaults;
      }
    } catch (err) {
      // nothing
    }
  }

  return Array.isArray(data) ? data : [data];
};
