/**
 * Created by sh on 15/4/13.
 */

'use strict';

const dayjs  = require('dayjs')
  , utc      = require('dayjs/plugin/utc')
  , timezone = require('dayjs/plugin/timezone')
  , debug    = require('debug')('light:db:mongo:type')
  , type     = require('./index');

// dependent on timezone plugin
dayjs.extend(utc);
dayjs.extend(timezone);

exports.parse = function (param, define, addition = {}) {

  if (type.isBlank(param)) {
    debug('is blank');
    return null;
  }

  if (param instanceof Date) {
    debug('is data object');
    return param;
  }

  if (dayjs.isDayjs()) {
    debug('is dayjs object');
    return param;
  }

  if (param.constructor.name === 'Moment') {
    debug('is moment object');
    return param;
  }

  if (typeof param === 'string' || param instanceof String) {
    // if (!/\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z/.test(param.valueOf())) {
    //   debug('incorrect date string');
    //   return null;
    // }
    const timezone = addition.tz || 'UTC'
      , date = dayjs.tz(param.valueOf().replace(/\//g, '-'), timezone);
    if (date.isValid()) {
      debug('successfully converted to date. timezone', timezone);
      return date.tz(timezone).toDate();
    }
    debug('incorrect date string');
  }

  return null;
};
