/**
 * Created by sh on 15/4/13.
 */

'use strict';

const debug = require('debug')('light:db:mongo:type')
  , type = require('./index');

exports.parse = function (param) {

  if (type.isBlank(param)) {
    debug('is blank');
    return null;
  }

  if (typeof param === 'number' || param instanceof Number) {
    return param.valueOf();
  }

  if (typeof param === 'string' || param instanceof String) {
    const parsed = Number(param.valueOf());
    if (Number.isNaN(parsed)) {
      debug('cannot be parse to numbers');
      return null;
    }
    return parsed;
  }

  debug('cannot be converted to numbers');
  return null;
};
