/**
 * Created by sh on 15/4/13.
 */

'use strict';

const { ObjectId } = require('mongodb')
  , debug = require('debug')('light:db:mongo:type')
  , type = require('./index');

exports.parse = function (param) {

  if (type.isBlank(param)) {
    debug('is blank');
    return null;
  }

  if (param instanceof ObjectId) {
    return param;
  }

  if ((typeof param === 'string' || param instanceof String) && param.length === 24) {
    try {
      return new ObjectId(param.valueOf());
    } catch (err) {
      debug('incorrect objectid string');
    }
  }

  return null;
};
