/**
 * Created by sh on 15/4/13.
 */

'use strict';

const { ObjectId } = require('mongodb')
  , dayjs = require('dayjs')
  , debug = require('debug')('light:db:mongo:type')
  , type = require('./index');

exports.parse = function (param) {
  if (typeof param === 'string' || param instanceof String) {
    return param.valueOf();
  }
  if (type.isBlank(param)) {
    debug('is blank');
    return '';
  }
  if (param instanceof ObjectId) {
    return param.toHexString();
  }
  if (param instanceof Date || dayjs.isDayjs(param) || param.constructor.name === 'Moment') {
    return param.toISOString();
  }
  if (param instanceof RegExp) {
    return param;
  }
  try {
    return JSON.stringify(param);
  } catch (err) {
    // nothing
  }
  return String(param);
};
