/**
 * @file 异常类。
 * @module light.core.error.common
 * @author qiou_kay@163.com
 * @version 1.0.0
 */


'use strict';

class AbstractError extends Error {

  constructor(msg, constr) {
    super();

    // If defined, pass the constr property to V8's
    // captureStackTrace to clean up the output
    Error.captureStackTrace(this, constr || this);

    // If defined, store a custom error message
    this.code = this.code || 'E0001';
    this.message = msg || 'Error';
  }

}

exports.AbstractError = AbstractError;
