
/** ********************** */
declare class AbstractError {
  constructor(msg: string)
  code: string
  message: string
}

/** ********************** */
declare class HttpError extends AbstractError {}

declare class BadRequest extends HttpError {}
declare class Unauthorized extends HttpError {}
declare class NotFound extends HttpError {}
declare class InternalServer extends HttpError {}
declare class Forbidden extends HttpError {}
declare class RequestTimeout extends HttpError {}


/** ********************** */
declare class ParamError extends AbstractError {}

declare class PasswordError extends ParamError {}
declare class TypeError extends ParamError {}
declare class EmptyError extends ParamError {}
declare class CaptchaError extends ParamError {}
declare class UsedError extends ParamError {}


/** ********************** */
declare class SystemError extends AbstractError {}

declare class ConfigError extends SystemError {}
declare class NoPermissionError extends SystemError {}
declare class ConflictError extends SystemError {}
declare class ParseError extends SystemError {}
declare class FileNotFoundError extends SystemError {}
declare class ClassNotFoundError extends SystemError {}
declare class MethodNotFoundError extends SystemError {}


/** ********************** */
declare class DBError extends AbstractError {}

declare class AddError extends DBError {}
declare class RemoveError extends DBError {}
declare class UpdateError extends DBError {}
declare class FindError extends DBError {}
declare class NotExistError extends DBError {}
declare class LockedError extends DBError {}
declare class NotCorrectError extends DBError {}


export class LightError {

  http: {
    HttpError: HttpError
    BadRequest: BadRequest
    Unauthorized: Unauthorized
    NotFound: NotFound
    InternalServer: InternalServer
    Forbidden: Forbidden
    RequestTimeout: RequestTimeout
  }

  parameter: {
    ParamError: ParamError
    TypeError: TypeError
    EmptyError: EmptyError
    UsedError: UsedError
    CaptchaError: CaptchaError
    PasswordError: PasswordError
  }

  system: {
    SystemError: SystemError
    ConfigError: ConfigError
    NoPermissionError: NoPermissionError
    ConflictError: ConflictError
    ParseError: ParseError
    FileNotFoundError: FileNotFoundError
    ClassNotFoundError: ClassNotFoundError
    MethodNotFoundError: MethodNotFoundError
  }

  db: {
    DBError: DBError
    AddError: AddError
    RemoveError: RemoveError
    UpdateError: UpdateError
    FindError: FindError
    NotExistError: NotExistError
    LockedError: LockedError
    NotCorrectError: NotCorrectError
  }

}
