/**
 * 多国语言转换
 * 词条key格式为 type.key 如 body.user.password
 * 根据指定的 lang 返回词条内容
 * @author r2space@gmail.com
 * @module lib/i18n
 * @version 1.0.0
 */

'use strict';

const debug = require('debug')('light:i18n');

class I18n {

  static catalog = [];

  static load(catalog) {
    this.catalog = [].concat(this.catalog).concat(catalog);
  }

  // eslint-disable-next-line id-length
  static i(key = '') {

    const [type, suffix] = key.split(/\.(.*)/);
    const row = this.catalog.find(item => (item.type === type && item.key === suffix));

    if (row && row.lang[this.lang]) {
      return row.lang[this.lang];
    }

    debug('key not defined', key, 'lang', this.lang);
    return key;
  }

}

module.exports = I18n;
