/**
 * 全局处理异常，这个是第一个koa中间件，负责采集所有后续的异常
 */

const response = require('../response');

class Exception {

  static use(app) {
    app.use(async (ctx, next) => {
      try {
        await next();
      } catch (error) {

        // 不使用koa默认的异常返回，而使用response发送json格式的异常
        response.sendError({ ctx }, error);

        // 生成 error 事件，供后续的 app.on('error', fn) 处理
        ctx.app.emit('error', error, ctx);
      }
    });
  }

}

module.exports = Exception;
