/**
 * @file notice
 * @author r2space@gmail.com
 * @module light.core.notice
 * @version 1.0.0
 */

'use strict';

// const request = require('request');

exports.send = function (params, callback) {

  // 支持钉钉机器人
  const { Dingtalk } = light.config.push;
  if (Dingtalk) {

    const options = {
      url    : Dingtalk,
      method : 'POST',
      headers: { 'Content-Type': 'application/json' },
      json   : params
    };

    if (callback) {
      return request(options, (err, response, body) => callback(err, body));
    }

    return new Promise((resolve, reject) => {
      request(options, (err, response, body) => {
        if (err) {
          return reject(err);
        }
        if (body.errcode) {
          return reject(body);
        }
        resolve(body);
      });
    });
  }

  return Promise.reject();
};


