/**
 * test/controllers/etl.js
 */

'use strict';


exports.init = function (handler, model, callback) {
  console.info('>> custom init');
  callback();
};

exports.before = function (handler, data, callback) {
  console.info('>> custom before');
  callback(null, data);
};

exports.parse = function (handler, row, callback) {
  console.info('>> custom parse', row);

  if (!row.lang) {
    return callback();
  }

  row.lang = row.lang.reduce((memo, item) => {
    const [key, val] = item.split(':');
    memo[key] = val;
    return memo;
  }, {});
  callback();
};

exports.after = function (handler, data, callback) {
  console.info('>> custom after');
  callback(null, data);
};

exports.valid = function (handler, row, callback) {
  console.info('>> custom valid');
  callback();
};

exports.dump = function (handler, data, callback) {
  console.info('>> custom dump');
  callback(null, data);
};

exports.end = function (handler, result, callback) {
  console.info('>> custom end');
  callback();
};
