/**
 * connection.test.js
 */

'use strict';

const connection = require('../../../../lib/db/mongo/connection');
const pool       = require('../../../../lib/db/mongo/pool');
const helper     = require('../../../helper');

describe('Connection', () => {

  afterAll(() => helper.clear());

  it('connect', async () => {
    const { client, db } = await connection.connect();
    expect(client.isConnected()).toBeTruthy();

    const info = await db.stats();
    expect(info.db).toBe('light');

    // 再次连接，使用连接池
    await connection.connect();
    expect(Object.keys(pool.connections)).toHaveLength(1);
  });

});
