/**
 * pool.test.js
 */

'use strict';

const pool = require('../../../../lib/db/mongo/pool');

describe('Pool', () => {

  it('add', async () => {

    const client = { close: jest.fn() };
    const db = {};

    pool.add('a', client, db);
    pool.add('a', client, db);
    pool.add('a', client, db);
    pool.add('b', client, db);

    expect(Object.keys(pool.connections)).toHaveLength(2);
    expect(pool.temporary).toHaveLength(2);

  });

  it('get', async () => {
    const res = pool.get('a', 1);
    expect(res).toHaveProperty('client');
    expect(pool.temporary).toHaveLength(0);
  });

  it('remove', async () => {
    pool.remove('a');
    expect(Object.keys(pool.connections)).toHaveLength(1);
  });

  it('destroy', async () => {
    await pool.destroy();
    expect(Object.keys(pool.connections)).toHaveLength(0);
  });
});
