/**
 * i18n.test.js
 */

'use strict';

const i18n = require('../../lib/i18n');

describe('I18n', () => {

  it('i', () => {
    i18n.load([{
      type: 'body',
      key : 'password.title',
      lang: {
        en: 'Password',
        ja: 'パアスワード',
        zh: '密码'
      }
    }]);
    i18n.lang = 'ja';

    expect(i18n.i('body.password.title')).toBe('パアスワード');
    expect(i18n.i('type.key')).toBe('type.key');
    expect(i18n.i('empty')).toBe('empty');
    expect(i18n.i()).toBe('');
  });

  it('i empty catalog', () => {
    i18n.load();
    expect(i18n.i('type.key')).toBe('type.key');
  });

});
