/**
 * middleware/health-check.test.js
 */

'use strict';

const util = require('./util');

describe('HealthCheck', () => {

  beforeAll(() => {
    util.setupKoa(['health-check', 'helloword']);
  });

  afterAll(() => util.clear());

  it('health check request', async () => {
    const res = await util.request.get('/health-check');
    expect(res.body).toEqual({});
  });

  it('normal request', async () => {
    const res = await util.request.get('/index.html');
    expect(res.text).toBe('Hello World');
  });

});
