/**
 * setting.test.js
 */

'use strict';

const setting = require('../../lib/setting');
const i18n    = require('../../lib/i18n');
const config  = require('../../lib/configuration');
const pool    = require('../../lib/db/mongo/pool');

describe('Setting', () => {

  afterAll(() => {
    delete process.env.APPLOCAL;
    pool.destroy(true);
  });

  it('load from mongo', async () => {

    await setting.init();

    expect(i18n.catalog.length).toBeGreaterThan(0);
    expect(config.catalog.length).toBeGreaterThan(0);
    expect(setting.struct.length).toBeGreaterThan(0);
    expect(setting.board.length).toBeGreaterThan(0);
    expect(setting.validator.length).toBeGreaterThan(0);
    expect(setting.route.length).toBeGreaterThan(0);
    expect(setting.menu.length).toBeGreaterThan(0);
    expect(setting.tenant.length).toBeGreaterThan(0);
  });

  it('load from file', async () => {

    process.env.APPLOCAL = true;
    await setting.init();

    expect(i18n.catalog.length).toBeGreaterThan(0);
    expect(config.catalog.length).toBeGreaterThan(0);
    expect(setting.struct.length).toBeGreaterThan(0);
    expect(setting.board.length).toBeGreaterThan(0);
    expect(setting.validator.length).toBeGreaterThan(0);
    expect(setting.route.length).toBeGreaterThan(0);
    expect(setting.menu.length).toBeGreaterThan(0);
    expect(setting.tenant.length).toBeGreaterThan(0);

  });

});
